# Overview

This Charm deploys the [Jupyter notebook](http://jupyter.org).

The Jupyter Notebook is a web application that allows you to create and share documents that contain live code, equations, visualizations and explanatory text. Uses include: data cleaning and transformation, numerical simulation, statistical modeling, machine learning and much more.

# Installation
To deploy this charm you will need at a minimum: a cloud provider,
a working Juju installation and a successful bootstrap. Once bootstrapped,
deploy this charm:

```
$ juju deploy cs:~attardi-h/jupyter-notebook password=PASSWORD
```

where `PASSWORD` is a password of your choice.
If you are using the Juju GUI, set the password with the configuration option `password` (default: `fast&furious`).

# Usage
This Charm deploys a Jupyter notebook server that will run at the URL:
```
   https://address:8888
```

where `address` is the public address of the VM, that is displayed with the command:

```
$ juju status
Unit                 Workload     Agent  Machine  Public address  Ports     Message
jupyter-notebook/0*  maintenance  idle   0        52.54.105.50    8888/tcp  Jupyter Notebook password: *******
```
If using the `Juju GUI`, the address is displayed by selecting the application `jupyter-notebook` on the left panel.

**Warning**

If you are using Safari, you must accept the server certificate, by
clicking **Show Certificate**, then opening **Trust** and choosing
**Always Trust** in `When using this certificate`, and finally **Continue**.

# Installing Kernels
The notebook comes preloaded with `Python3`.

Other kernels can be installed according to [these instructions](https://github.com/jupyter/jupyter/wiki/Jupyter-kernels).

## Python2
Add `pip2 install ipykernel; python2 -m ipykernel install --user` to `extra_install`.

## Octave
Add `octave` to the option `extra_packages`, `octave_kernel` to `python_packages` and `python -m octave_kernel.install` to `extra_install`.
You can test it by uploading [this sample](http://nbviewer.jupyter.org/github/Calysto/octave_kernel/blob/master/octave_kernel.ipynb).

# Contact Information

## Authors

This software was created at the [Consortium GARR](https://www.garr.it).

 - Giuseppe Attardi <giuseppe.attardi@garr.it>

